Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/il/ip/ip.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -129,5 +129,5 @@
  * @return		The result parameter.
  */
-static int ip_release_and_return(packet_t *packet, int result)
+static int ip_release_and_return(packet_t packet, int result)
 {
 	pq_release_remote(ip_globals.net_phone, packet_get_id(packet));
@@ -139,10 +139,10 @@
  * Searches the registered protocols.
  *
- * @return		The found ICMP phone.
- * @return		ENOENT if the ICMP is not registered.
+ * @returns		The found ICMP phone.
+ * @returns		ENOENT if the ICMP is not registered.
  */
 static int ip_get_icmp_phone(void)
 {
-	ip_proto_t *proto;
+	ip_proto_ref proto;
 	int phone;
 
@@ -160,17 +160,17 @@
  * @param[in] packet	The packet or the packet queue to be reported as faulty.
  * @param[in] header	The first packet IP header. May be NULL.
- * @return		EOK on success.
- * @return		EINVAL if there are no data in the packet.
- * @return		EINVAL if the packet is a fragment.
- * @return		ENOMEM if the packet is too short to contain the IP
+ * @returns		EOK on success.
+ * @returns		EINVAL if there are no data in the packet.
+ * @returns		EINVAL if the packet is a fragment.
+ * @returns		ENOMEM if the packet is too short to contain the IP
  *			header.
- * @return		EAFNOSUPPORT if the address family is not supported.
- * @return		EPERM if the protocol is not allowed to send ICMP
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		EPERM if the protocol is not allowed to send ICMP
  *			notifications. The ICMP protocol itself.
- * @return		Other error codes as defined for the packet_set_addr().
- */
-static int ip_prepare_icmp(packet_t *packet, ip_header_t *header)
-{
-	packet_t *next;
+ * @returns		Other error codes as defined for the packet_set_addr().
+ */
+static int ip_prepare_icmp(packet_t packet, ip_header_ref header)
+{
+	packet_t next;
 	struct sockaddr *dest;
 	struct sockaddr_in dest_in;
@@ -187,5 +187,5 @@
 
 		// get header
-		header = (ip_header_t *) packet_get_data(packet);
+		header = (ip_header_ref) packet_get_data(packet);
 		if (!header)
 			return EINVAL;
@@ -227,12 +227,12 @@
  * @param[in] packet	The packet or the packet queue to be reported as faulty.
  * @param[in] header	The first packet IP header. May be NULL.
- * @return		The found ICMP phone.
- * @return		EINVAL if the error parameter is set.
- * @return		EINVAL if the ICMP phone is not found.
- * @return		EINVAL if the ip_prepare_icmp() fails.
+ * @returns		The found ICMP phone.
+ * @returns		EINVAL if the error parameter is set.
+ * @returns		EINVAL if the ICMP phone is not found.
+ * @returns		EINVAL if the ip_prepare_icmp() fails.
  */
 static int
-ip_prepare_icmp_and_get_phone(services_t error, packet_t *packet,
-    ip_header_t *header)
+ip_prepare_icmp_and_get_phone(services_t error, packet_t packet,
+    ip_header_ref header)
 {
 	int phone;
@@ -248,6 +248,6 @@
  * @param[in] client_connection The client connection processing function. The
  *			module skeleton propagates its own one.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int ip_initialize(async_client_conn_t client_connection)
@@ -293,20 +293,20 @@
  *
  * @param[in,out] ip_netif Network interface specific data.
- * @return		EOK on success.
- * @return		ENOTSUP if DHCP is configured.
- * @return		ENOTSUP if IPv6 is configured.
- * @return		EINVAL if any of the addresses is invalid.
- * @return		EINVAL if the used ARP module is not known.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if DHCP is configured.
+ * @returns		ENOTSUP if IPv6 is configured.
+ * @returns		EINVAL if any of the addresses is invalid.
+ * @returns		EINVAL if the used ARP module is not known.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			net_get_device_conf_req() function.
- * @return		Other error codes as defined for the bind_service()
+ * @returns		Other error codes as defined for the bind_service()
  *			function.
- * @return		Other error codes as defined for the specific
+ * @returns		Other error codes as defined for the specific
  *			arp_device_req() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			nil_packet_size_req() function.
  */
-static int ip_netif_initialize(ip_netif_t *ip_netif)
+static int ip_netif_initialize(ip_netif_ref ip_netif)
 {
 	measured_string_t names[] = {
@@ -344,9 +344,9 @@
 		}
 	};
-	measured_string_t *configuration;
+	measured_string_ref configuration;
 	size_t count = sizeof(names) / sizeof(measured_string_t);
 	char *data;
 	measured_string_t address;
-	ip_route_t *route;
+	ip_route_ref route;
 	in_addr_t gateway;
 	int index;
@@ -378,5 +378,5 @@
 			return ENOTSUP;
 		} else if (ip_netif->ipv == IPV4) {
-			route = (ip_route_t *) malloc(sizeof(ip_route_t));
+			route = (ip_route_ref) malloc(sizeof(ip_route_t));
 			if (!route) {
 				net_free_settings(configuration, data);
@@ -486,10 +486,10 @@
  * @param[in] device_id	The device identifier.
  * @param[in] mtu	The new mtu value.
- * @return		EOK on success.
- * @return		ENOENT if device is not found.
+ * @returns		EOK on success.
+ * @returns		ENOENT if device is not found.
  */
 static int ip_mtu_changed_message(device_id_t device_id, size_t mtu)
 {
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -511,10 +511,10 @@
  * @param[in] device_id	The device identifier.
  * @param[in] state	The new state value.
- * @return		EOK on success.
- * @return		ENOENT if device is not found.
+ * @returns		EOK on success.
+ * @returns		ENOENT if device is not found.
  */
 static int ip_device_state_message(device_id_t device_id, device_state_t state)
 {
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -539,13 +539,13 @@
  * @param[in] packet	The packet to be prefixed.
  * @param[in] last	The last header to be copied.
- * @return		The prefixed middle header.
- * @return		NULL on error.
- */
-static ip_header_t *
-ip_create_middle_header(packet_t *packet, ip_header_t *last)
-{
-	ip_header_t *middle;
-
-	middle = (ip_header_t *) packet_suffix(packet, IP_HEADER_LENGTH(last));
+ * @returns		The prefixed middle header.
+ * @returns		NULL on error.
+ */
+static ip_header_ref
+ip_create_middle_header(packet_t packet, ip_header_ref last)
+{
+	ip_header_ref middle;
+
+	middle = (ip_header_ref) packet_suffix(packet, IP_HEADER_LENGTH(last));
 	if (!middle)
 		return NULL;
@@ -562,7 +562,7 @@
  * @param[in] first	The original header to be copied.
  */
-static void ip_create_last_header(ip_header_t *last, ip_header_t *first)
-{
-	ip_option_t *option;
+static void ip_create_last_header(ip_header_ref last, ip_header_ref first)
+{
+	ip_option_ref option;
 	size_t next;
 	size_t length;
@@ -575,5 +575,5 @@
 	// process all ip options
 	while (next < first->header_length) {
-		option = (ip_option_t *) (((uint8_t *) first) + next);
+		option = (ip_option_ref) (((uint8_t *) first) + next);
 		// skip end or noop
 		if ((option->type == IPOPT_END) ||
@@ -613,21 +613,21 @@
  * @param[in,out] packet The packet to be sent.
  * @param[in] destination The destination hardware address.
- * @return		EOK on success.
- * @return		EINVAL if the packet is too small to contain the IP
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is too small to contain the IP
  *			header.
- * @return		EINVAL if the packet is too long than the IP allows.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the packet_set_addr()
+ * @returns		EINVAL if the packet is too long than the IP allows.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the packet_set_addr()
  *			function.
  */
 static int
-ip_prepare_packet(in_addr_t *source, in_addr_t dest, packet_t *packet,
-    measured_string_t *destination)
+ip_prepare_packet(in_addr_t *source, in_addr_t dest, packet_t packet,
+    measured_string_ref destination)
 {
 	size_t length;
-	ip_header_t *header;
-	ip_header_t *last_header;
-	ip_header_t *middle_header;
-	packet_t *next;
+	ip_header_ref header;
+	ip_header_ref last_header;
+	ip_header_ref middle_header;
+	packet_t next;
 	int rc;
 
@@ -636,5 +636,5 @@
 		return EINVAL;
 
-	header = (ip_header_t *) packet_get_data(packet);
+	header = (ip_header_ref) packet_get_data(packet);
 	if (destination) {
 		rc = packet_set_addr(packet, NULL, (uint8_t *) destination->value,
@@ -660,5 +660,5 @@
 
 	if (pq_next(packet)) {
-		last_header = (ip_header_t *) malloc(IP_HEADER_LENGTH(header));
+		last_header = (ip_header_ref) malloc(IP_HEADER_LENGTH(header));
 		if (!last_header)
 			return ENOMEM;
@@ -666,5 +666,5 @@
 		next = pq_next(packet);
 		while (pq_next(next)) {
-			middle_header = (ip_header_t *) packet_prefix(next,
+			middle_header = (ip_header_ref) packet_prefix(next,
 			    IP_HEADER_LENGTH(last_header));
 			if (!middle_header) {
@@ -698,5 +698,5 @@
 		}
 
-		middle_header = (ip_header_t *) packet_prefix(next,
+		middle_header = (ip_header_ref) packet_prefix(next,
 		    IP_HEADER_LENGTH(last_header));
 		if (!middle_header) {
@@ -746,14 +746,14 @@
  * @param[in] dest	The destiantion address.
  * @param[in] addrlen	The address length.
- * @return		EOK on success.
- * @return		ENOMEM if the target packet is too small.
- * @return		Other error codes as defined for the packet_set_addr()
+ * @returns		EOK on success.
+ * @returns		ENOMEM if the target packet is too small.
+ * @returns		Other error codes as defined for the packet_set_addr()
  *			function.
- * @return		Other error codes as defined for the pq_insert_after()
+ * @returns		Other error codes as defined for the pq_insert_after()
  *			function.
  */
 static int
-ip_fragment_packet_data(packet_t *packet, packet_t *new_packet,
-    ip_header_t *header, ip_header_t *new_header, size_t length,
+ip_fragment_packet_data(packet_t packet, packet_t new_packet,
+    ip_header_ref header, ip_header_ref new_header, size_t length,
     const struct sockaddr *src, const struct sockaddr *dest, socklen_t addrlen)
 {
@@ -799,28 +799,28 @@
  * @param[in] suffix	The minimum suffix size.
  * @param[in] addr_len	The minimum address length.
- * @return		EOK on success.
- * @return		EINVAL if the packet_get_addr() function fails.
- * @return		EINVAL if the packet does not contain the IP header.
- * @return		EPERM if the packet needs to be fragmented and the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet_get_addr() function fails.
+ * @returns		EINVAL if the packet does not contain the IP header.
+ * @returns		EPERM if the packet needs to be fragmented and the
  *			fragmentation is not allowed.
- * @return		ENOMEM if there is not enough memory left.
- * @return		ENOMEM if there is no packet available.
- * @return		ENOMEM if the packet is too small to contain the IP
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		ENOMEM if there is no packet available.
+ * @returns		ENOMEM if the packet is too small to contain the IP
  *			header.
- * @return		Other error codes as defined for the packet_trim()
+ * @returns		Other error codes as defined for the packet_trim()
  *			function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			ip_create_middle_header() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			ip_fragment_packet_data() function.
  */
 static int
-ip_fragment_packet(packet_t *packet, size_t length, size_t prefix, size_t suffix,
+ip_fragment_packet(packet_t packet, size_t length, size_t prefix, size_t suffix,
     socklen_t addr_len)
 {
-	packet_t *new_packet;
-	ip_header_t *header;
-	ip_header_t *middle_header;
-	ip_header_t *last_header;
+	packet_t new_packet;
+	ip_header_ref header;
+	ip_header_ref middle_header;
+	ip_header_ref last_header;
 	struct sockaddr *src;
 	struct sockaddr *dest;
@@ -838,5 +838,5 @@
 
 	// get header
-	header = (ip_header_t *) packet_get_data(packet);
+	header = (ip_header_ref) packet_get_data(packet);
 	if (!header)
 		return EINVAL;
@@ -853,5 +853,5 @@
 
 	// allocate as much as originally
-	last_header = (ip_header_t *) packet_suffix(new_packet,
+	last_header = (ip_header_ref) packet_suffix(new_packet,
 	    IP_HEADER_LENGTH(header));
 	if (!last_header)
@@ -919,14 +919,14 @@
  * @param[in] addr_len	The minimum address length.
  * @param[in] error	The error module service.
- * @return		The packet or the packet queue of the allowed length.
- * @return		NULL if there are no packets left.
- */
-static packet_t *
-ip_split_packet(packet_t *packet, size_t prefix, size_t content, size_t suffix,
+ * @returns		The packet or the packet queue of the allowed length.
+ * @returns		NULL if there are no packets left.
+ */
+static packet_t
+ip_split_packet(packet_t packet, size_t prefix, size_t content, size_t suffix,
     socklen_t addr_len, services_t error)
 {
 	size_t length;
-	packet_t *next;
-	packet_t *new_packet;
+	packet_t next;
+	packet_t new_packet;
 	int result;
 	int phone;
@@ -986,16 +986,16 @@
  * @param[in] dest	The destination address.
  * @param[in] error	The error module service.
- * @return		EOK on success.
- * @return		Other error codes as defined for the arp_translate_req()
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for the arp_translate_req()
  *			function.
- * @return		Other error codes as defined for the ip_prepare_packet()
+ * @returns		Other error codes as defined for the ip_prepare_packet()
  *			function.
  */
 static int
-ip_send_route(packet_t *packet, ip_netif_t *netif, ip_route_t *route,
+ip_send_route(packet_t packet, ip_netif_ref netif, ip_route_ref route,
     in_addr_t *src, in_addr_t dest, services_t error)
 {
 	measured_string_t destination;
-	measured_string_t *translation;
+	measured_string_ref translation;
 	char *data;
 	int phone;
@@ -1062,12 +1062,12 @@
  *			NULL.
  * @param[in] destination The destination address.
- * @return		The found route.
- * @return		NULL if no route was found.
- */
-static ip_route_t *
-ip_netif_find_route(ip_netif_t *netif, in_addr_t destination)
+ * @returns		The found route.
+ * @returns		NULL if no route was found.
+ */
+static ip_route_ref
+ip_netif_find_route(ip_netif_ref netif, in_addr_t destination)
 {
 	int index;
-	ip_route_t *route;
+	ip_route_ref route;
 
 	if (!netif)
@@ -1090,11 +1090,11 @@
  *
  * @param[in] destination The destination address.
- * @return		The found route.
- * @return		NULL if no route was found.
- */
-static ip_route_t *ip_find_route(in_addr_t destination) {
+ * @returns		The found route.
+ * @returns		NULL if no route was found.
+ */
+static ip_route_ref ip_find_route(in_addr_t destination) {
 	int index;
-	ip_route_t *route;
-	ip_netif_t *netif;
+	ip_route_ref route;
+	ip_netif_ref netif;
 
 	// start with the last netif - the newest one
@@ -1116,10 +1116,10 @@
  *
  * @param[in] netif	The network interface.
- * @return		The IP address.
- * @return		NULL if no IP address was found.
- */
-static in_addr_t *ip_netif_address(ip_netif_t *netif)
-{
-	ip_route_t *route;
+ * @returns		The IP address.
+ * @returns		NULL if no IP address was found.
+ */
+static in_addr_t *ip_netif_address(ip_netif_ref netif)
+{
+	ip_route_ref route;
 
 	route = ip_routes_get_index(&netif->routes, 0);
@@ -1136,10 +1136,10 @@
  * @param[in] phone	The transport layer module phone.
  * @param[in] received_msg The receiving function.
- * @return		EOK on success.
- * @return		EINVAL if the protocol parameter and/or the service
+ * @returns		EOK on success.
+ * @returns		EINVAL if the protocol parameter and/or the service
  *			parameter is zero.
- * @return		EINVAL if the phone parameter is not a positive number
+ * @returns		EINVAL if the phone parameter is not a positive number
  *			and the tl_receive_msg is NULL.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 static int
@@ -1147,5 +1147,5 @@
     tl_received_msg_t received_msg)
 {
-	ip_proto_t *proto;
+	ip_proto_ref proto;
 	int index;
 
@@ -1153,5 +1153,5 @@
 		return EINVAL;
 
-	proto = (ip_proto_t *) malloc(sizeof(ip_protos_t));
+	proto = (ip_proto_ref) malloc(sizeof(ip_protos_t));
 	if (!proto)
 		return ENOMEM;
@@ -1180,10 +1180,10 @@
 ip_device_req_local(int il_phone, device_id_t device_id, services_t netif)
 {
-	ip_netif_t *ip_netif;
-	ip_route_t *route;
+	ip_netif_ref ip_netif;
+	ip_route_ref route;
 	int index;
 	int rc;
 
-	ip_netif = (ip_netif_t *) malloc(sizeof(ip_netif_t));
+	ip_netif = (ip_netif_ref) malloc(sizeof(ip_netif_t));
 	if (!ip_netif)
 		return ENOMEM;
@@ -1247,10 +1247,10 @@
 
 static int
-ip_send_msg_local(int il_phone, device_id_t device_id, packet_t *packet,
+ip_send_msg_local(int il_phone, device_id_t device_id, packet_t packet,
     services_t sender, services_t error)
 {
 	int addrlen;
-	ip_netif_t *netif;
-	ip_route_t *route;
+	ip_netif_ref netif;
+	ip_route_ref route;
 	struct sockaddr *addr;
 	struct sockaddr_in *address_in;
@@ -1361,5 +1361,5 @@
  * @param[out] content	The maximum content size.
  * @param[out] suffix	The minimum reserved suffix size.
- * @return		EOK on success.
+ * @returns		EOK on success.
  */
 static int
@@ -1367,5 +1367,5 @@
     size_t *content, size_t *suffix)
 {
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 	int index;
 
@@ -1418,7 +1418,7 @@
  *
  * @param[in] header	The packet IP header to be read.
- * @return		The packet destination address.
- */
-static in_addr_t ip_get_destination(ip_header_t *header)
+ * @returns		The packet destination address.
+ */
+static in_addr_t ip_get_destination(ip_header_ref header)
 {
 	in_addr_t destination;
@@ -1439,20 +1439,20 @@
  * @param[in] header	The first packet IP header. May be NULL.
  * @param[in] error	The packet error service.
- * @return		EOK on success.
- * @return		ENOTSUP if the packet is a fragment.
- * @return		EAFNOSUPPORT if the address family is not supported.
- * @return		ENOENT if the target protocol is not found.
- * @return		Other error codes as defined for the packet_set_addr()
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if the packet is a fragment.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		ENOENT if the target protocol is not found.
+ * @returns		Other error codes as defined for the packet_set_addr()
  *			function.
- * @return		Other error codes as defined for the packet_trim()
+ * @returns		Other error codes as defined for the packet_trim()
  *			function.
- * @return		Other error codes as defined for the protocol specific
+ * @returns		Other error codes as defined for the protocol specific
  *			tl_received_msg() function.
  */
 static int
-ip_deliver_local(device_id_t device_id, packet_t *packet, ip_header_t *header,
+ip_deliver_local(device_id_t device_id, packet_t packet, ip_header_ref header,
     services_t error)
 {
-	ip_proto_t *proto;
+	ip_proto_ref proto;
 	int phone;
 	services_t service;
@@ -1544,18 +1544,18 @@
  * @param[in] device_id	The source device identifier.
  * @param[in] packet	The received packet to be processed.
- * @return		EOK on success.
- * @return		EINVAL if the TTL is less than two.
- * @return		EINVAL if the checksum is invalid.
- * @return		EAFNOSUPPORT if the address family is not supported.
- * @return		ENOENT if no route was found.
- * @return		ENOENT if the packet is for another host and the routing
+ * @returns		EOK on success.
+ * @returns		EINVAL if the TTL is less than two.
+ * @returns		EINVAL if the checksum is invalid.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		ENOENT if no route was found.
+ * @returns		ENOENT if the packet is for another host and the routing
  *			is disabled.
  */
 static int
-ip_process_packet(device_id_t device_id, packet_t *packet)
-{
-	ip_header_t *header;
+ip_process_packet(device_id_t device_id, packet_t packet)
+{
+	ip_header_ref header;
 	in_addr_t dest;
-	ip_route_t *route;
+	ip_route_ref route;
 	int phone;
 	struct sockaddr *addr;
@@ -1564,5 +1564,5 @@
 	int rc;
 
-	header = (ip_header_t *) packet_get_data(packet);
+	header = (ip_header_ref) packet_get_data(packet);
 	if (!header)
 		return ip_release_and_return(packet, ENOMEM);
@@ -1647,6 +1647,6 @@
     in_addr_t netmask, in_addr_t gateway)
 {
-	ip_route_t *route;
-	ip_netif_t *netif;
+	ip_route_ref route;
+	ip_netif_ref netif;
 	int index;
 
@@ -1659,5 +1659,5 @@
 	}
 
-	route = (ip_route_t *) malloc(sizeof(ip_route_t));
+	route = (ip_route_ref) malloc(sizeof(ip_route_t));
 	if (!route) {
 		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
@@ -1681,5 +1681,5 @@
 ip_set_gateway_req_local(int ip_phone, device_id_t device_id, in_addr_t gateway)
 {
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -1715,5 +1715,5 @@
 static int
 ip_received_error_msg_local(int ip_phone, device_id_t device_id,
-    packet_t *packet, services_t target, services_t error)
+    packet_t packet, services_t target, services_t error)
 {
 	uint8_t *data;
@@ -1721,8 +1721,8 @@
 	icmp_type_t type;
 	icmp_code_t code;
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 	measured_string_t address;
-	ip_route_t *route;
-	ip_header_t *header;
+	ip_route_ref route;
+	ip_header_ref header;
 
 	switch (error) {
@@ -1734,5 +1734,5 @@
 
 		data = packet_get_data(packet);
-		header = (ip_header_t *)(data + offset);
+		header = (ip_header_ref)(data + offset);
 
 		// destination host unreachable?
@@ -1782,6 +1782,6 @@
 	in_addr_t *dest;
 	in_addr_t *src;
-	ip_route_t *route;
-	ipv4_pseudo_header_t *header_in;
+	ip_route_ref route;
+	ipv4_pseudo_header_ref header_in;
 
 	if (!destination || (addrlen <= 0))
@@ -1829,5 +1829,5 @@
 
 	*headerlen = sizeof(*header_in);
-	header_in = (ipv4_pseudo_header_t *) malloc(*headerlen);
+	header_in = (ipv4_pseudo_header_ref) malloc(*headerlen);
 	if (!header_in)
 		return ENOMEM;
@@ -1849,17 +1849,17 @@
  * @param[in] device_id	The source device identifier.
  * @param[in,out] packet The received packet.
- * @return		EOK on success and the packet is no longer needed.
- * @return		EINVAL if the packet is too small to carry the IP
+ * @returns		EOK on success and the packet is no longer needed.
+ * @returns		EINVAL if the packet is too small to carry the IP
  *			packet.
- * @return		EINVAL if the received address lengths differs from the
+ * @returns		EINVAL if the received address lengths differs from the
  *			registered values.
- * @return		ENOENT if the device is not found in the cache.
- * @return		ENOENT if the protocol for the device is not found in
+ * @returns		ENOENT if the device is not found in the cache.
+ * @returns		ENOENT if the protocol for the device is not found in
  *			the cache.
- * @return		ENOMEM if there is not enough memory left.
- */
-static int ip_receive_message(device_id_t device_id, packet_t *packet)
-{
-	packet_t *next;
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+static int ip_receive_message(device_id_t device_id, packet_t packet)
+{
+	packet_t next;
 
 	do {
@@ -1879,6 +1879,6 @@
  * @param[out] answer_count The last parameter for the actual answer in the
  *			answer parameter.
- * @return		EOK on success.
- * @return		ENOTSUP if the message is not known.
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if the message is not known.
  *
  * @see ip_interface.h
@@ -1890,5 +1890,5 @@
     int *answer_count)
 {
-	packet_t *packet;
+	packet_t packet;
 	struct sockaddr *addr;
 	size_t addrlen;
@@ -2037,6 +2037,6 @@
 /** Starts the module.
  *
- * @return EOK on success.
- * @return Other error codes as defined for each specific module start function.
+ * @returns EOK on success.
+ * @returns Other error codes as defined for each specific module start function.
  */
 int main(int argc, char *argv[])
Index: uspace/srv/net/il/ip/ip.h
===================================================================
--- uspace/srv/net/il/ip/ip.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/il/ip/ip.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -59,4 +59,9 @@
 typedef struct ip_netif ip_netif_t;
 
+/** Type definition of the IP network interface specific data pointer.
+ * @see ip_netif
+ */
+typedef ip_netif_t *ip_netif_ref;
+
 /** Type definition of the IP protocol specific data.
  * @see ip_proto
@@ -64,8 +69,18 @@
 typedef struct ip_proto ip_proto_t;
 
+/** Type definition of the IP protocol specific data pointer.
+ * @see ip_proto
+ */
+typedef ip_proto_t *ip_proto_ref;
+
 /** Type definition of the IP route specific data.
  *  @see ip_route
  */
 typedef struct ip_route	ip_route_t;
+
+/** Type definition of the IP route specific data pointer.
+ *  @see ip_route
+ */
+typedef ip_route_t *ip_route_ref;
 
 /** IP network interfaces.
@@ -89,5 +104,5 @@
 struct ip_netif {
 	/** ARP module. Assigned if using ARP. */
-	module_t *arp;
+	module_ref arp;
 	/** Broadcast address. */
 	in_addr_t broadcast;
@@ -131,5 +146,5 @@
 	in_addr_t gateway;
 	/** Parent netif. */
-	ip_netif_t *netif;
+	ip_netif_ref netif;
 	/** Target network mask. */
 	in_addr_t netmask;
